#
# This file is part of python sample package for the BROADWAY2 package.
#
# MIT License

# Copyright (c) 2013-2022 FibreCode GmbH <info@fibrecode.com>

# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:

# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.

# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# socket_echo_client_dgram.py
# Can be direct used alo for UDP-ECHO Server tests (default is Port=7)

import socket
import sys

DefaultPacketLen = 256

def main(args):
    if len(args) == 1:
        ipAddr = 'localhost'
        port = 10000
        dataLen=DefaultPacketLen
    elif len(args) == 2:
        ipAddr = args[1]
        port = 10000
        dataLen=DefaultPacketLen
    elif len(args) == 3:
        ipAddr = args[1]
        port = int(args[2])
        dataLen=DefaultPacketLen
    elif len(args) == 4:
        ipAddr = args[1]
        port = int(args[2])
        dataLen=int(args[3])

    udpData = ''
    for j in range(0,dataLen//2):
        udpData += '{0:02X}'.format(j)

    # Create a UDP socket
    sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)

    serverAddress = (ipAddr, port)
    message = udpData.encode()

    try:

        # Send data
        print('sending {0}'.format(message))
        sent = sock.sendto(message, serverAddress)

        # Receive response
        print('waiting to receive')
        data, server = sock.recvfrom(65000)
        print('received {!r}'.format(data))

    finally:
        print('closing socket')
        sock.close()


if __name__ == "__main__":
    main(sys.argv)
